*-----------------------------------------------------------------------------
* Rmctoolt.prg - based on the WinTest.prg provided with xHarbour, and used to
*                test the use of Rainer Morgen's free Rmchart.dll with xHarbour
*                and isolated from FWH (to rule it out as a problem source).
*
*              - mnBarsImage() is where most of the testing is done here.
*-----------------------------------------------------------------------------

STATIC hRmcDll,nCtrlID,hWnd,hDC

#include "hbdll.ch"

#include "winapi.ch"
#include "wingdi.ch"
#include "structures.ch"
#include "DLLxHb.ch"
#include "Rmchart.ch"

#define True   1
#define False  0

pragma pack(4)

typedef struct {;
  CTYPE_DOUBLE nDouble[5];
} DataStructD5

typedef struct {;
  CTYPE_LONG nLong[5];
} ColorStructL5

#xtranslate TextOut( <x,...> ) =>

PROCEDURE Main()

*   LOCAL hWnd
   LOCAL wc := (struct WNDCLASS)
   LOCAL msg

   wc:style         := CS_OWNDC | CS_DBLCLKS
   wc:lpfnWndProc   := WinCallBackPointer( @MainWndProc() )
   //wc:cbClsExtra    := 0
   //wc:cbWndExtra    := 0
   wc:hInstance     := GetModuleHandle()
   //wc:hIcon         := 0
   wc:hCursor       := LoadCursor( NIL, IDC_IBEAM )
   wc:hbrBackground := COLOR_WINDOW + 1
   wc:lpszClassName := "TestWindow"
   //wc:lpszMenuName  := NIL

   hRmcDll  := LoadLibrary( "RMCHART.DLL" )

   IF RegisterClass( wc ) > 0
      hWnd := CreateWindowEx( 0, "TestWindow", "Rmchart Test", WS_OVERLAPPEDWINDOW, ;
                              100, 100, 800, 600, 0, 0, wc:hInstance, NIL )

      IF hWnd > 0
         ShowWindow( hWnd, SW_SHOW )

         WHILE GetMessage( @msg, 0, 0, 0 )
            TranslateMessage( msg )
            DispatchMessage( msg )
         END
      ELSE
         TraceLog( GetLastError(), FormatMessage() )
         Alert( "Failed to create window!" )
      ENDIF
   ELSE
      TraceLog( GetLastError(), FormatMessage() )
      Alert( "Failed to register class!" )
   ENDIF

   FreeLibrary( hRmcDll )

   RETURN

FUNCTION MainWndProc( hWnd, message, wParam, lParam )

   LOCAL ps
   STATIC nCnt := 0

   //TraceLog( hWnd, message, wParam, lParam )

   SWITCH message
      CASE WM_SETFOCUS
         RETURN 0

      CASE WM_PAINT
         hDC := BeginPaint( hWnd, @ps )
         //TextOut( hDC, 20, 20, "Hello World", Len( "Hello World" ) )
         EndPaint( hWnd, ps )
         IF nCnt = 0         // Prevent recursion.
            mnBarsImage()
         ENDIF
         nCnt++

         RETURN 0


      CASE WM_DESTROY
         PostQuitMessage( 0 )
         TraceLog( "Quit" )
         RETURN 0
   END

RETURN DefWindowProc( hWnd, message, wParam, lParam )
*----------------------------------------------------
  // This test function for creating a bar graph necessarily uses a
  // building block approach, calling a series of Rmchart functions in sequence
  // because that is the way Rmchart creates a graph, one step at a time...
STATIC FUNCTION mnBarsImage()
    LOCAL nRetVal := 0
    LOCAL sLabels := ""
    LOCAL oData  IS DataStructD5
    LOCAL oColor IS ColorStructL5
    
    nCtrlID  := hWnd  // Better to use some predefined CONSTANT ID.
    
    //************** Create the chart **********************
   nRetVal = RMC_CreateChart( ;
                 hWnd                , ;  // nParentHandle
                 nCtrlID             , ;  // nCtrlID
                 0                   , ;  // nTop
                 0                   , ;  // nLeft
                 600                 , ;  // nWidth
                 500                 , ;  // nHeight
                 ColorTransparent    , ;  // nBackColor
                 RMC_CTRLSTYLEIMAGE  , ;  // nCtrlStyle
                 False               , ;  // nExportOnly
                 ""                  , ;  // sBgImage  // "seasky.jpg" - background jpeg, not needed for this test
                 ""                  , ;  // sFontName
                 100                 , ;  // nToolTipwidth
                 0                     ;  // nBitmapBKColor
                 )

    If nRetVal < 0 ; IsError(41) ; RETURN nil ; EndIf

    //************** Add Region 1 *****************************
   nRetVal = RMC_AddRegion( ;
                 nCtrlID             , ;  // nCtrlID
                 5                   , ;  // nLeft
                 5                   , ;  // nTop
                 -5                  , ;  // nWidth
                 -5                  , ;  // nHeight
                 ""                  , ;  // sFooter
                 False                 ;  // nShowBorder
                 )

    If nRetVal < 0 ; IsError(42) ; RETURN nil ; EndIf

    //************** Add grid to region 1 *****************************
   nRetVal = RMC_AddGrid( ;
                 nCtrlID             , ;  // nCtrlID
                 1                   , ;  // nRegion
                 ColorTransparent    , ;  // nGridBackColor
                 False               , ;  // nAsGradient
                 0                   , ;  // nLeft
                 0                   , ;  // nTop
                 0                   , ;  // nWidth
                 0                   , ;  // nHeight
                                       ;  // nBiColor
                 )


    If nRetVal < 0 ; IsError(43) ; RETURN nil ; EndIf

    //************** Add data axis to region 1 *****************************
   nRetVal = RMC_AddDataAxis( ;
                 nCtrlID             , ;  // nCtrlID
                 1                   , ;  // nRegion
                 RMC_DATAAXISBOTTOM  , ;  // nAlignment
                 0.0                 , ;  // nMinValue -DOUBLE so MUST have decimal!!
                 100.0               , ;  // nMaxValue -DOUBLE so MUST have decimal!!
                 11                  , ;  // nTickCount
                 8                   , ;  // nFontsize
                 ColorGreen          , ;  // nTextColor
                 ColorGreen          , ;  // nLineColor
                 RMC_LINESTYLEDOT    , ;  // nLinestyle
                 0                   , ;  // nDecimalDigits
                 ""                  , ;  // sUnit
                 ""                  , ;  // sText
                                     , ;  // sLabels
                                       ;  // nLabelAlignment
                 )


    If nRetVal < 0 ; IsError(44) ; RETURN nil ; EndIf
    //************** Add label axis to region 1 *****************************

    sLabels = "Label 1*Label 2*Label 3*Label 4*Label 5"

   nRetVal = RMC_AddLabelAxis( ;
                 nCtrlID             , ;  // nCtrlID
                 1                   , ;  // nRegion
                 sLabels             , ;  // sLabels (separated by asterisk)
                 1                   , ;  // nCount
                 5                   , ;  // ntickCount
                 RMC_LABELAXISBOTTOM , ;  // nAlignment
                 8                   , ;  // nFontSize
                 ColorBlack          , ;  // ntextColor
                 RMC_TEXTCENTER      , ;  // nTextAlignment
                 ColorGreen          , ;  // nLineColor
                 RMC_LINESTYLENONE   , ;  // nLineStyle
                 ""                    ;  // sText
                 )


    If nRetVal < 0 ; IsError(45) ; RETURN nil ; EndIf
    //************** Add Series 1 to region 1 *******************************
    //****** Read data values ******

    oData:nDouble[1] := 50.0    // Your data goes into these 5 slots
    oData:nDouble[2] := 70.0
    oData:nDouble[3] := 40.0
    oData:nDouble[4] := 60.0
    oData:nDouble[5] := 30.0

   nRetVal = RMC_AddBarSeries( ;
                 nCtrlID             , ;  // nCtrlID
                 1                   , ;  // nRegion
                 oData[1]            , ;  // nFirstDataValue
                 5                   , ;  // nDataValuesCount
                 RMC_BARSINGLE       , ;  // nType
                 RMC_BAR_FLAT_GRADIENT2 , ;  // nStyle
                 True                , ;  // nIsLucent
                 ColorTransparent    , ;  // nColor
                 False               , ;  // nIsHorizontal
                 1                   , ;  // nWhichAxis
                 RMC_VLABEL_NONE     , ;  // nValuelabelOn
                 1                   , ;  // nPointsPerColumn
                 RMC_HATCHBRUSH_OFF    ;  // nHatchMode
                 )


    If nRetVal < 0 ; IsError(46) ; RETURN nil ; EndIf
    
    // Lets set some CustomToolTipTexts: (these don't work, don't know why)
    RMC_SetCustomToolTipText( nCtrlID, 1, 1, 1, ;
                              "First Bar" + Chr(13) + Chr(10) + ;
                              "Value: 50" + Chr(13) + Chr(10) + ;
                              "Color: Blue" )
    RMC_SetCustomToolTipText( nCtrlID, 1, 1, 2, ;
                              "Second Bar" + Chr(13) + Chr(10) + ;
                              "Value: 70" + Chr(13) + Chr(10) + ;
                              "Color: Green" )
    RMC_SetCustomToolTipText( nCtrlID, 1, 1, 3, ;
                              "Third Bar" + Chr(13) + Chr(10) + ;
                              "Value: 40" + Chr(13) + Chr(10) + ;
                              "Color: Red" )
    RMC_SetCustomToolTipText( nCtrlID, 1, 1, 4, ;
                              "Fourth Bar" + Chr(13) + Chr(10) + ;
                              "Value: 60" + Chr(13) + Chr(10) + ;
                              "Color: Yellow" )
    // Last bar gets no CustomText, so default ToolTipText (=Value) is used.
    
    // Switch ToolTips on
    RMC_AddToolTips( nCtrlID, hWnd, 100 )
*    RMC_SetToolTipWidth( nCtrlID, 100 )    // Alternate way to switch on TT.
 
    nRetVal = RMC_Draw( nCtrlID )
    If nRetVal < 0 ; IsError(47) ; RETURN nil ; EndIf

RETURN nil


*-------------
STATIC FUNCTION IsError(nError)
IF EMPTY(nError)
   nError := 0
ENDIF

   MessageBox(hWnd,"An error occurred at: "+LTRIM(STR(nError)) +CRLF+;
             "Please make a note of this number.")

   // Each error number can be traced to a specific place in this prg.

RETURN nil
*----------------------------------------------------
// For indirect use of DLLCALL() via DLLxHb.ch...
// (These are in Rmc4xHb.prg, but we're not using that for this test.)

DLLxHb FUNCTION RMC_CREATECHART( ;           // RMC_CreateChart
                 nParentHndl, ;     // HWND
                 nCtrlId, ;
                 nX, ;
                 nY, ;
                 nWidth, ;
                 nHeight, ;
                 nBackColor, ;
                 nCtrlStyle, ;
                 nExportOnly, ;
                 sBgImage, ;
                 sFontName, ;
                 nToolTipWidth, ;
                 nBitmapBKColor ;
                 ) LIB hRmcDll

DLLxHb FUNCTION RMC_ADDREGION( ;             // RMC_AddRegion
                 nCtrlID, ;
                 nLeft, ;
                 nTop , ;
                 nWidth, ;
                 nHeight, ;
                 sFooter, ;
                 nShowBorder ;
                 ) LIB hRmcDll 

DLLxHb FUNCTION RMC_ADDBARSERIES(  ;         // RMC_AddBarSeries 
                 nCtrlId             , ;
                 nRegion             , ;
                 @nFirstDataValue    , ;
                 nDataValuesCount    , ;
                 nType               , ;
                 nStyle              , ;
                 nIsLucent           , ;
                 nColor              , ;
                 nIsHorizontal       , ;
                 nWhichDataAxis      , ;
                 nValueLabelOn       , ;
                 nPointsPerColumn    , ;
                 nHatchMode ) LIB hRmcDll 

DLLxHb FUNCTION RMC_ADDDATAAXIS( ;           // RMC_AddDataAxis
                 nCtrlID, ;
                 nRegion, ;
                 nAlignment, ;
                 nMinValue, ;
                 nMaxValue, ;
                 nTickCount, ;
                 nFontsize, ;
                 nTextColor, ;
                 nLineColor, ;
                 nLineStyle, ;
                 nDecimalDigits, ;
                 sUnit, ;
                 sText, ;
                 sLabels, ;
                 nLabelAlignment ;
                 ) LIB hRmcDll

DLLxHb FUNCTION RMC_ADDGRID( ;               // RMC_AddGrid
                 nCtrlID, ;
                 nRegion, ;
                 nBackColor, ;
                 nAsGradient, ;
                 nLeft, ;
                 nTop, ;
                 nWidth, ;
                 nHeight, ;
                 nBiColor ;
                 ) LIB hRmcDll 

DLLxHb FUNCTION RMC_ADDLABELAXIS( ;          // RMC_AddLabelAxis
                 nCtrlID, ;
                 nRegion, ;
                 sLabel, ;     
                 nCount, ;
                 nTickCount, ;
                 nAlignment, ;
                 nFontsize, ;
                 nTextColor, ;
                 nTextAlignment, ;
                 nLineColor, ;
                 nLineStyle, ;
                 sText ;                 
                 ) LIB hRmcDll 

DLLxHb FUNCTION RMC_ADDTOOLTIPS( ;   // RMC_AddToolTips
                 nCtrlID, ;
                 hWnd, ;
                 nToolTipWidth ;
                 ) LIB hRmcDll 

DLLxHb FUNCTION RMC_DRAW( ;                  // RMC_Draw
                 nCtrlID ;
                 ) LIB hRmcDll 

DLLxHb FUNCTION RMC_SETCUSTOMTOOLTIPTEXT( ;  // RMC_SetCustomToolTipText
                  nCtrlId, ;
                  nRegion, ;
                  nSeries, ;
                  nDataIndex, ;
                  sText ;
                  ) LIB hRmcDll 

DLLxHb FUNCTION RMC_SETTOOLTIPWIDTH( ;       // RMC_SetToolTipWidth
                 nCtrlID, ;
                 nWidth ;
                 ) LIB hRmcDll 

DLLxHb FUNCTION RMC_DELETECHART( nCtrlId ) LIB hRmcDll

*--------------------------------------------------------
